﻿using System;
using System.Windows;
using System.Windows.Media;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Microsoft.Phone.Tasks;
using VoIPserviceCheckerWP75.Modell;
using VoIPserviceCheckerWP75.Utils;

namespace VoIPserviceCheckerWP75
{
    public partial class MainPage : PhoneApplicationPage
    {
        private SipRegister sipRegister;
        private ProgressIndicator progressIndicator;
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            SetDefaultState();
            Init();
        }

        void Init()
        {
            sipRegister = new SipRegister();
            sipRegister.RegistrationCompleted += new EventHandler<GenericEventArgs<RegistrationResult>>(sipRegister_RegistrationCompleted);
            resultControl.DataContext = this;
            inputControl.DataContext = this;
            startControl.DataContext = this;
        }

        void sipRegister_RegistrationCompleted(object sender, GenericEventArgs<RegistrationResult> e)
        {
            resultControl.ShowImage(e.Item);
            ChangeState(GuiState.ShowResult);
        }

        void SetDefaultState()
        {

            inputControl.Visibility = Visibility.Collapsed;
            resultControl.Visibility = Visibility.Collapsed;
            startControl.Visibility = Visibility.Visible;
        }


        public void RegisterToPbx(string userName, string authName, string password, string url)
        {
          
            ChangeState(GuiState.ShowInputForm);
            ShowProgressIndicator();
            
            sipRegister.RegistertoPbx(userName, authName, password, url);
        }

        public void ShowInputForm()
        {
            ChangeState(GuiState.ShowInputForm);
        }

        public void GoBacktoInput()
        {
            ChangeState(GuiState.BackToInputForm);
        }

        void ChangeState(GuiState state)
        {
            Dispatcher.BeginInvoke(() =>
            {
                switch (state)
                {
                    case GuiState.ShowInputForm:
                        startControl.Visibility = Visibility.Collapsed;
                        inputControl.Visibility = Visibility.Visible;
                        break;
                    case GuiState.ShowResult:
                        progressIndicator.IsIndeterminate = false;
                        progressIndicator.Text = "";
                        inputControl.Visibility = Visibility.Collapsed;
                        resultControl.Visibility = Visibility.Visible;
                        break;
                    case GuiState.BackToInputForm:
                        inputControl.EnableOkButton();
                        inputControl.Visibility = Visibility.Visible;
                        resultControl.Visibility = Visibility.Collapsed;
                        break;
                }
            });
        }

        private void ShowProgressIndicator()
        {
            SystemTray.SetIsVisible(this, true);
             progressIndicator = new ProgressIndicator();
            progressIndicator.IsVisible = true;
            progressIndicator.IsIndeterminate = true;
            progressIndicator.Text = "Progress";
            SystemTray.SetProgressIndicator(this, progressIndicator);
        }

        private void TextBlock_MouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            WebBrowserTask wtb = new WebBrowserTask();
            wtb.Uri = new Uri("http://www.ozekiphone.com", UriKind.Absolute);
            wtb.Show();
        }

        

    }
}